package com.example.karro.locationapp;

import java.net.MalformedURLException;
import java.net.URL;
import java.time.DayOfWeek;
import java.time.LocalDate;
import java.time.ZoneId;
import java.time.temporal.TemporalAdjusters;
import java.time.temporal.WeekFields;

import javax.json.*;

import java.io.*;
import java.util.ArrayList;
import java.util.Locale;
import java.util.HashMap;
import java.util.Calendar;
import java.util.TimeZone;

public class  Json_Amica {

    private static HashMap<String, ArrayList<String>> map;

    static String base_url = "http://www.amica.fi/modules/json/json/Index?";
    static String carelia = "costNumber=0417"; // Carelia
    static String tori36 = "costNumber=0401"; // Tori36
    static String aura = "costNumber=0413"; // Aura
    static String futura = "costNumber=041702"; // Futura
    //static String date;



    //public static void main(String[] args) {


    public static HashMap<String, ArrayList<String>> getAmicaLunch() {

        //LocalDate localDate = LocalDate.now();

        String kk = "";
        String pv = "";

        Calendar cal = Calendar.getInstance();   // GregorianCalendar
        cal.setTimeZone(TimeZone.getTimeZone("Europe/Helsinki"));

        int kuukausi = cal.get(Calendar.MONTH)+1;
        if (kuukausi<10)
            kk = ("0" + Integer.toString(kuukausi));
        else kk = Integer.toString(kuukausi);

        int paiva = cal.get(Calendar.DAY_OF_MONTH);
        if (paiva<10)
            pv = ("0" + Integer.toString(paiva));
        else pv = Integer.toString(paiva);


        String localDate = (Integer.toString(cal.get(Calendar.YEAR)) + "-" + kk + "-" + pv);

        System.out.println("moi \n" + localDate);
        /*
        int firstDayOfWeek = cal.get(Calendar.DAY_OF_MONTH) - (cal.get(Calendar.DAY_OF_WEEK)-2);
        date = "&firstDay=" + Integer.toString(firstDayOfWeek)
                + "&lastDay=" + Integer.toString(firstDayOfWeek+7);
        */

       /* Locale locale = Locale.GERMANY;
        DayOfWeek firstDayOfWeek =  WeekFields.of(locale).getFirstDayOfWeek();
        DayOfWeek lastDayOfWeek = DayOfWeek.of(((firstDayOfWeek.getValue() + 5) % DayOfWeek.values().length) + 1);
        LocalDate firstDay = LocalDate.now(ZoneId.systemDefault()).with(TemporalAdjusters.previousOrSame(firstDayOfWeek));
        LocalDate lastDay = LocalDate.now(ZoneId.systemDefault()).with(TemporalAdjusters.nextOrSame(lastDayOfWeek));

        date = "&firstDay=" + firstDay.toString() + "&lastDay=" + lastDay.toString();*/

        URL carelia_url = null;
        URL tori36_url = null;
        URL aura_url = null;
        URL futura_url = null;

        try {
            carelia_url = new URL(base_url + carelia /*+ date*/ + "&language=en");
            tori36_url = new URL(base_url + tori36 /*+ date*/ + "&language=fi");
            aura_url = new URL(base_url + aura /*+ date*/ + "&language=en");
            futura_url = new URL(base_url + futura /*+ date*/ + "&language=en");
        } catch (MalformedURLException e) {
            ;
        }

        ArrayList<URL> urls = new ArrayList<URL>();
        urls.add(carelia_url);
        urls.add(tori36_url);
        urls.add(aura_url);
        urls.add(futura_url);

        System.out.println(urls);

        ArrayList<String> lunchmenu = new ArrayList<String>();
        map = new HashMap<String, ArrayList<String>>();
        ArrayList<String> cafeterias = new ArrayList<String>();
        cafeterias.add("Carelia");
        cafeterias.add("Tori36");
        cafeterias.add("Aura");
        cafeterias.add("Futura");

        JsonArray mdays = null;
        JsonArray menus = null;
        JsonArray meals = null;

        int i = 0;

        //System.out.println(urls);

        for (URL u : urls) {
            lunchmenu = new ArrayList<String>();
           // System.out.println("HALLOO: local date: " + localDate);
            try {
                //System.out.println("HALLOO1: local date: " + localDate);
                //System.out.println("URL1: " + u);
                InputStream is = u.openStream();
                //System.out.println("URL2: " + u);
                JsonReader rdr = Json.createReader(is);
                //System.out.println("URL3: " + u);
                JsonObject obj = rdr.readObject();

                //System.out.println("HALLOO2: local date: " + localDate);

                mdays = obj.getJsonArray("MenusForDays");

                for (JsonObject day : mdays.getValuesAs(JsonObject.class)) {
                    //System.out.println("HALLOO3: local date: " + localDate);
                    JsonString date = day.getJsonString("Date");



                    menus = day.getJsonArray("SetMenus");
                    for (JsonObject menu : menus.getValuesAs(JsonObject.class)) {
                        if (! menu.isNull("Price"))
                            menu.getJsonString("Price").toString();

                        meals = menu.getJsonArray("Components");
                        for (JsonString meal : meals.getValuesAs(JsonString.class)) {

                            String d = "";
                            for (char c : date.toString().toCharArray()) {
                                if (c == 'T') {
                                    break;
                                } else {
                                    if (c != '"') {
                                        d += Character.toString(c);
                                    }
                                }
                            }
                            System.out.println("d: " + d + " localDate: " + localDate);
                            if (d.equals(localDate)) {
                                lunchmenu.add(meal.toString());
                                //System.out.println("KUKKULUURUU" + lunchmenu);
                            }
                        }
                    }
                }

                is.close();

            } catch (Exception e) {
                //System.out.println("Ex");
                //System.out.println(lunchmenu);
            }

            ArrayList<String> help = new ArrayList<String>();
            String h = "";

            for (String s : lunchmenu) {
                h = "";
                for (char c : s.toCharArray()) {
                    if (c != '"') {
                        h += Character.toString(c);
                    }
                }
                help.add(h);
            }

            lunchmenu.clear();
            lunchmenu.addAll(help);

            map.put(cafeterias.get(i), lunchmenu);
            i++;

        }
        System.out.println("Json_Amica map: " + map);
        return map;
    }

/*    public static HashMap<String, ArrayList<String>> getAmicaLunch() {
        main(null);
        return map;
    }*/

} 