package com.example.karro.locationapp;

import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;
import android.widget.ArrayAdapter;
import android.widget.SimpleAdapter;
import android.widget.ListView;
import android.content.Intent;

import java.util.Collection;
import java.util.HashMap;
import java.util.ArrayList;
import java.util.Map;
import java.util.Set;

import com.google.android.gms.maps.model.LatLng;

public class ListActivity extends AppCompatActivity {

    private ListView listView;
    private SimpleAdapter adapter;
    public static HashMap<String, ArrayList<String>> map;


    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_list);
        overridePendingTransition(R.anim.slide_in, R.anim.slide_out);

        main();
    }

    public void main() {
        arrangeByDistance(null);
        adapter.notifyDataSetChanged();
    }

    public void arrangeByDistance(View view) {
        HashMap<String, LatLng> map = new HashMap<String, LatLng>();
        map.clear();
        map = MapsActivity.getLatLng();

        ArrayList<String> cafeteria_list = new ArrayList<String>();
        cafeteria_list.clear();

        LatLng user = map.get("User");
        map.remove("User");

        while (!map.isEmpty()) {
            double min = -1;
            String nearest = "";

            for (String s : map.keySet()) {
                float dist = MapsActivity.getDistance((Double) map.get(s).latitude, (Double) user.latitude,
                        (Double) map.get(s).longitude, (Double) user.longitude);
                double d_dist = (double) dist;
                if (d_dist < min || min == -1) {
                    nearest = s;
                    min = dist;
                }
            }

            cafeteria_list.add(nearest);
            map.remove(nearest);
        }

        showMenu(cafeteria_list);
    }

    public void arrangeByName(View view) {
        ArrayList<String> list = MapsActivity.getNames();
        ArrayList<String> sorted_list = new ArrayList<String>();

        while (!list.isEmpty()) {
            String min = "";

            for (String s : list) {
                if (min == "" || min.compareTo(s) > 0) {
                    min = s;
                }
            }

            sorted_list.add(min);
            list.remove(min);
        }

        showMenu(sorted_list);
    }

    public void showMenu(ArrayList<String> cafeteria_list) {

        listView = (ListView) findViewById(R.id.listView1);

        ArrayList<String> lunch_list = new ArrayList<String>();
        lunch_list = getLunchMenu(cafeteria_list);

      /*  for (int i = 0; i < 5; i++) {
            lunch_list.add("<Lunch list>");
        }*/

        ArrayList<Map<String, String>> data = new ArrayList<Map<String, String>>();

        int i = 0;
        for (String s1 : cafeteria_list) {
            String s2 = lunch_list.get(i);
            Map<String, String> map = new HashMap<String, String>();
            map.put("title", s1);
            map.put("menu", s2);
            data.add(map);
            i++;
        }

        adapter = new SimpleAdapter(this, data,
                android.R.layout.simple_list_item_2,
                new String[] {"title", "menu"},
                new int[] {android.R.id.text1, android.R.id.text2});
        listView.setAdapter(adapter);

    }

    public ArrayList<String> getLunchMenu(ArrayList<String> cafeteria_list) {
        ArrayList<String> lunch_list = new ArrayList<String>();

        Thread t1 = new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ListActivity.map = Json_Amica.getAmicaLunch();

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }});

        t1.start();

        Thread t2 = new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ArrayList<String> listLouhi;
                    listLouhi = JsoupLouhi.menu();
                    ListActivity.map.put("Louhi", listLouhi);

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }});

        t2.start();

        try {
            t2.join();  // wait for threadS to finish
            t1.join();
        } catch (Exception e) {
            e.printStackTrace();
        }

        for (String s : cafeteria_list) {
            System.out.println("Map 3: " + ListActivity.map);
            if (ListActivity.map != null && ListActivity.map.containsKey(s.toString())) {
                String s3 = "";
                for (String s2 : ListActivity.map.get(s)) {
                    s3 += s2 + "\n";
                }
                lunch_list.add(s3);
            } else {
                lunch_list.add("No lunch menu available");
            }
        }

        System.out.println(lunch_list);

        return lunch_list;
    }

    public void quit(View view) {
        finish();
        this.overridePendingTransition(R.anim.slide_in, R.anim.slide_out);
    }


}
